<?php

namespace Kscc\Tender\Repositories\Presenter;

use League\Fractal\TransformerAbstract;
use Hashids;

class TenderTransformer extends TransformerAbstract
{
    public function transform(\Kscc\Tender\Models\Tender $tender)
    {
        return [
            'id'                => $tender->getRouteKey(),
            'key'               => [
                'public'    => $tender->getPublicKey(),
                'route'     => $tender->getRouteKey(),
            ], 
            'slug'              => $tender->slug,
            'name'              => $tender->name,
            'details'           => $tender->details,
            'images'            => $tender->images,
            'user_id'           => $tender->user_id,
            'user_type'         => $tender->user_type,
            'deleted_at'        => $tender->deleted_at,
            'url'               => [
                'public'    => trans_url('tender/'.$tender->getPublicKey()),
                'user'      => guard_url('tender/tender/'.$tender->getRouteKey()),
            ], 
            'status'            => trans('app.'.$tender->status),
            'created_at'        => format_date($tender->created_at),
            'updated_at'        => format_date($tender->updated_at),
        ];
    }
}