<?php

namespace Kscc\Tender;

use User;

class Tender
{
    /**
     * $tender object.
     */
    protected $tender;

    /**
     * Constructor.
     */
    public function __construct(\Kscc\Tender\Interfaces\TenderRepositoryInterface $tender)
    {
        $this->tender = $tender;
    }

    /**
     * Returns count of tender.
     *
     * @param array $filter
     *
     * @return int
     */
    public function count()
    {
        return  0;
    }

    /**
     * Make gadget View
     *
     * @param string $view
     *
     * @param int $count
     *
     * @return View
     */
    public function gadget($view = 'admin.tender.gadget', $count = 10)
    {

        if (User::hasRole('user')) {
            $this->tender->pushCriteria(new \Litepie\Kscc\Repositories\Criteria\TenderUserCriteria());
        }

        $tender = $this->tender->scopeQuery(function ($query) use ($count) {
            return $query->orderBy('id', 'DESC')->take($count);
        })->all();

        return view('tender::' . $view, compact('tender'))->render();
    }
}
